#include "header.h"
 
void fogyaszt(osztottMemoriaTipus* p)
{
	//a termelo elkezdi levenni a termekeket a futoszalagrol
	int item;

 	sem_wait(&(p->tele));
	sem_wait(&(p->cmut));

	item = p->buffer[p->nextout];
	printf("%d\n",item);
	p->nextout++;
	p->nextout %= BUFFER_SIZE;

	sem_post(&(p->cmut));
	sem_post(&(p->ures));
}

int main()
{
	int shmfd = lekerOsztottMemoriaID();
	int t = 0;
	osztottMemoriaTipus * p;
	int shared_seg_size = sizeof(osztottMemoriaTipus);
	/* requesting the shared segment --  mmap() */    
	p = (osztottMemoriaTipus *)mmap(NULL, shared_seg_size, PROT_READ | PROT_WRITE, MAP_SHARED, shmfd, 0);
	if (p == NULL) {
	 	perror("In mmap()");
	        exit(1);
	}
 
	for(t=0;t<20;++t){
		fogyaszt(p);   
}
 
  if (shm_unlink(SHMOBJ_PATH) != 0){
        perror("In shm_unlink(SHMOBJ_PATH)");
        exit(1);
  } 

  return 0;
}
